###############################################################################
# Views module
# This module contains all classes implemeting widget views.
###############################################################################

INCLUDEPATH += .

PUBLIC_HEADERS += \
    mapplicationpageview.h \
    mcomboboxview.h \
    mdialogview.h \
    mmodalscenewindowview.h \
    mextendingbackgroundview.h \
    mescapebuttonpanelview.h \
    mhomebuttonpanelview.h \
    minfobannereventview.h \
    minfobannerinformationview.h \
    mbannerview.h \
    mgriditemview.h \
    mapplicationmenuview.h \
    mmenuobjectview.h \
    mmessageboxview.h \
    moverlayview.h \
    mobjectmenubasicview.h \
    mobjectmenuview.h \
    mpannablewidgetview.h \
    mpopuplistview.h \
    mprogressindicatorbarview.h \
    msheetview.h \
    msliderview.h \
    mspinnerview.h \
    mtexteditview.h \
    mtoolbartabview.h \
    mtoolbarview.h \
    mseparatorview.h \
    mcompleterview.h \
    mlistview.h \
    mscenewindowview.h \
    mlabelview.h \
    mpositionindicatorview.h \
    mbuttonview.h \
    mimagewidgetview.h \
    mbuttoniconview.h \
    mbuttonswitchview.h \
    mbuttontabview.h \
    mcheckboxview.h \
    mcontainerview.h \
    mcontentitemview.h \
    mnavigationbarview.h \
    mlistitemview.h \
    mbubbleitemview.h \
    mbasicsheetheaderview.h \


PRIVATE_HEADERS += \
    mborderdecorationroundedcornersview.h \
    mstylablewidgetview_p.h \
    mstatusbarview.h \
    mextendingbackgroundview_p.h \
    mtexteditview_p.h \
    mtextmagnifier.h \
    mtopleveloverlay.h \
    meditortoolbar.h \
    meditortoolbararrow.h \
    mapplicationmenuview_p.h \
    mapplicationmenubuttonview.h \
    mmenuobjectview_p.h \
    mobjectmenuview_p.h \
    mprogressindicatorbarview_p.h \
    mcompleterview_p.h \
    msheetview_p.h \
    mbasicsheetheaderview_p.h \
    msliderview_p.h \
    mspinnerview_p.h \
    mlistview_p.h \
    mbuttongrouplayoutpolicy_p.h \
    mtoolbarview_p.h \
    mtoolbartabview_p.h \
    mtoolbarlayoutpolicy.h \
    mpannablewidgetview_p.h \
    mlistindexview_p.h \
    mlistitemview_p.h \
    mescapebuttonpanelview_p.h \
    mhomebuttonpanelview_p.h \
    mviewconstants.h \
    mdialoginternalbox_p.h \
    mdockwidgetview.h \
    mscenelayereffectdimview.h \
    mlistindexview.h \
    mnavigationbarview_p.h \
    mbuttontransition.h \
    mbuttondefaulttransition.h \
    mbuttonexpandingbackgroundtransition.h \
    mbuttonimplodingbackgroundtransition.h \
    mbuttontabtransition.h \
    mlabelview_p.h \
    ../corelib/core/mdynamicpropertywatcher.h \ # an internal helper class that is also needed by the view lib
    mcolorcomboboxview_p.h \
    mcolorlistview_p.h \
    mcolorwidget.h \
    mcolorcomboboxview.h \
    mcolorlistview.h \

SOURCES += \
    mapplicationpageview.cpp \
    mborderdecorationroundedcornersview.cpp \
    mcomboboxview.cpp \
    mdialogview.cpp \
    mmodalscenewindowview.cpp \
    mextendingbackgroundview.cpp \
    mescapebuttonpanelview.cpp \
    mhomebuttonpanelview.cpp \
    minfobannereventview.cpp \
    minfobannerinformationview.cpp \
    mbannerview.cpp \
    mgriditemview.cpp \
    mapplicationmenuview.cpp \
    mmenuobjectview.cpp \
    mmessageboxview.cpp \
    moverlayview.cpp \
    mobjectmenubasicview.cpp \
    mobjectmenuview.cpp \
    mpannablewidgetview.cpp \
    mpopuplistview.cpp \
    mprogressindicatorbarview.cpp \
    msheetview.cpp \
    mbasicsheetheaderview.cpp \
    msliderview.cpp \
    mspinnerview.cpp \
    mstatusbarview.cpp \
    mtexteditview.cpp \
    mtextmagnifier.cpp \
    mtopleveloverlay.cpp \
    meditortoolbar.cpp \
    meditortoolbararrow.cpp \
    mtoolbarlayoutpolicy.cpp \
    mtoolbartabview.cpp \
    mtoolbarview.cpp \
    mseparatorview.cpp \
    mstylablewidgetview.cpp \
    mcompleterview.cpp \
    mlistview.cpp \
    mlistview_p.cpp \
    mbuttongrouplayoutpolicy_p.cpp \
    mscenewindowview.cpp \
    mlabelview.cpp \
    mlabelview_rich.cpp \
    mlabelview_simple.cpp \
    mpositionindicatorview.cpp \
    mapplicationmenubuttonview.cpp \
    mbuttonview.cpp \
    mbuttontabview.cpp \
    mimagewidgetview.cpp \
    mbuttoniconview.cpp \
    mbuttonswitchview.cpp \
    mcheckboxview.cpp \
    mcontainerview.cpp \
    mdockwidgetview.cpp \
    mcontentitemview.cpp \
    mnavigationbarview.cpp \
    mscenelayereffectdimview.cpp \
    mlistindexview.cpp \
    mlistitemview.cpp \
    mbubbleitemview.cpp \
    mbuttondefaulttransition.cpp \
    mbuttonexpandingbackgroundtransition.cpp \
    mbuttonimplodingbackgroundtransition.cpp \
    mbuttontabtransition.cpp \
    ../corelib/core/mdynamicpropertywatcher.cpp \ # an internal helper class that is also needed by the view lib
    mcolorcomboboxview.cpp \
    mcolorlistview.cpp \
    mcolorwidget.cpp \

