/***************************************************************************
**
** Copyright (C) 2010, 2011 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (directui@nokia.com)
**
** This file is part of libmeegotouch.
**
** If you have questions regarding the use of this file, please contact
** Nokia at directui@nokia.com.
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation
** and appearing in the file LICENSE.LGPL included in the packaging
** of this file.
**
****************************************************************************/

#ifndef UT_MBUTTON_H
#define UT_MBUTTON_H

#include <QtTest/QtTest>
#include <QObject>

#include <mbutton.h>

Q_DECLARE_METATYPE(MButton *);

class Ut_MButton : public QObject
{
    Q_OBJECT

private slots:
    void init();
    void cleanup();
    void initTestCase();
    void cleanupTestCase();

    void testConstructionAndDestruction();
    void testIcon();
    void testIconID();
    void testToggledIconID();
    void testText();
    void testTextVisible();
    void testCheckable();
    void testIconVisible();
    void testPressedReleased();
    void testPressedCanceled();
    void testGroup();
    void testConstructorWithModel();

    void setView();

    void click();
    void toggle();
private:
    MButton *m_subject;
    MButton *m_tmp;
};

#endif
